#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "txt.h"
#include <X11/XKBlib.h>
#include <X11/Intrinsic.h>
#include <X11/extensions/XKBgeom.h>
#include <X11/extensions/XKM.h>
#include <X11/extensions/XKBfile.h>
#include <X11/extensions/XKBui.h>
#include <X11/extensions/XKBrules.h>
#include "key.xpm"

extern GtkWidget *window;
GtkWidget *key_map_w;
GtkWidget *key_txt_w;
GtkWidget *key_name_w;
char *xf86head;

void key_sel (GtkWidget *widget, gpointer data)
{
	XkbDescPtr      xkb;
	XkbComponentNamesRec    getcomps;
	XkbRF_RulesPtr          rules;
        XkbRF_VarDefsRec        defs;
        FILE                    *fp;
	char	*cp1,*cp2;
	Display *disp;
	char buf[512];
	
	buf[0]= 0;
	strcat(buf, "cp /usr/share/keymaps/i386/*/");
	strcat(buf, GTK_ENTRY(widget)->text_mb);
	strcat(buf, ".map.gz "TARGET"/etc/kbd/default.map.gz");
	system(buf);
	buf[0]= 0;
	strcat(buf, "/bin/loadkeys "TARGET"/etc/kbd/default.map.gz");
	system(buf);

	disp = GDK_WINDOW_XDISPLAY(window->window);
	xkb=XkbGetKeyboard(disp,
		XkbGBN_AllComponentsMask,XkbUseCoreKbd);
        getcomps.keymap   = "";
        getcomps.keycodes = "";
        getcomps.compat   = "";
        getcomps.types    = "";
        getcomps.symbols  = "";
        getcomps.geometry = "";
	fp = fopen("/usr/X11R6/lib/X11/xkb/rules/xfree86", "r");
	rules= XkbRF_Create(0,0);
	XkbRF_LoadRules(fp,rules);
	buf[0]= 0;
	cp2 = &buf[0];
	strcat(buf, GTK_ENTRY(widget)->text_mb);
	cp1 = strchr(buf, '-');
	if (cp1>0) {*cp1 = 0;}
	if (!strcmp(buf,"cf")) { 		cp2 = "ca";
	} else if (!strcmp(buf,"ANSI")) { 	cp2 = "dvorak";
	} else if (!strcmp(buf,"it2")) {       	cp2 = "it";
	} else if (!strcmp(buf,"uk")) {       	cp2 = "en_US";
	} else if (!strcmp(buf,"ru_win")) {     cp2 = "ru";
	}
		
	defs.model   =  NULL;
	defs.layout  = cp2;
	defs.variant = NULL; /* "nodeadkeys" */
        defs.options = NULL; /* "ctrl:swapcaps" */
	bzero((char *)&getcomps, sizeof(XkbComponentNamesRec));
	XkbRF_GetComponents(rules, &defs, &getcomps);
		
	xkb = XkbGetKeyboardByName(disp, XkbUseCoreKbd, &getcomps,
                        XkbGBN_AllComponentsMask, 0, True);
	XtFree(getcomps.keymap);
        XtFree(getcomps.keycodes);
        XtFree(getcomps.compat);
        XtFree(getcomps.types);
        XtFree(getcomps.symbols);
        XtFree(getcomps.geometry);
        XkbRF_Free(rules,True);
        fclose(fp);

}

void page_key(GtkWidget *table) 
{
	GdkPixmap *pixmap;
        GdkBitmap *mask;
        GtkWidget *pixmapwid;
	GtkStyle  *style;
	GtkWidget *entry;
	GtkWidget *text;
	GList *cbitems = NULL;
	GtkWidget *cb;
	GtkWidget *label;
	char buffer[1024];
	char *pos;
	int i,fd;
	size_t len;
	system("ls /usr/share/keymaps/i386/*/*.map.gz |"
		" cut -f1 -d'.' | cut -f7 -d'/' > /tmp/kbd.txt");
	fd = open("/tmp/kbd.txt",O_RDONLY);
	len = read(fd, buffer, 1024);
	if (len <0) {return;}
	pos = &buffer[0];
	for (i=0;i<len;i++) {
		if (buffer[i] == '\n') {
			buffer[i] = 0;
			cbitems = g_list_append(cbitems,pos);
			pos = &buffer[i]+1;
		}
	}
	cb = gtk_combo_new ();
	gtk_combo_set_popdown_strings (GTK_COMBO (cb), cbitems);
	gtk_editable_set_editable(GTK_EDITABLE(GTK_COMBO(cb)->entry),FALSE);
	//gtk_entry_set_text (GTK_ENTRY (GTK_COMBO(cb)->entry), "hello world");
	gtk_table_attach_defaults (GTK_TABLE(table), cb,7,14,1,3);
	gtk_signal_connect (GTK_OBJECT (GTK_COMBO(cb)->entry), 
		"changed",
		GTK_SIGNAL_FUNC(key_sel),
		GTK_OBJECT (cb));
		
	gtk_widget_show (cb);
	
	label = gtk_label_new(key_map[DEF_LANG]);
	key_map_w = label;
	gtk_table_attach_defaults (GTK_TABLE(table), label,1,7,1,3);
	gtk_widget_show (label);

	style = gtk_widget_get_default_style();
	pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
                                &style->bg[GTK_STATE_NORMAL], key_xpm);
	pixmapwid = gtk_pixmap_new (pixmap, mask);
        gtk_table_attach_defaults (GTK_TABLE(table),pixmapwid,
                                1,9,7,9);
	gtk_widget_show(pixmapwid);

	text = gtk_text_new (NULL, NULL);
	key_txt_w = text;
	gtk_table_attach_defaults (GTK_TABLE(table), text,10,15,5,11);
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
		key_txt[DEF_LANG],-1);
	gtk_widget_show(text);
	

	entry = gtk_entry_new ();
        gtk_table_attach_defaults (GTK_TABLE(table), entry, 7,14,13,15);
        gtk_widget_show(entry);
	
	label = gtk_label_new(key_name[DEF_LANG]);
	key_name_w = label;
        gtk_table_attach_defaults (GTK_TABLE(table), label,1,7,13,15);
        gtk_widget_show (label);

}

char *xf86head = "Section \"Files\"\n"
	"RgbPath     \"/usr/X11R6/lib/X11/rgb\"\n"
	"FontPath   \"/usr/X11R6/lib/X11/fonts/misc/\"\n"
	"FontPath   \"/usr/X11R6/lib/X11/fonts/75dpi/:unscaled\"\n"
	"FontPath   \"/usr/X11R6/lib/X11/fonts/100dpi/:unscaled\"\n"
	"FontPath   \"/usr/X11R6/lib/X11/fonts/Type1/\"\n"
	"FontPath   \"/usr/X11R6/lib/X11/fonts/Speedo/\"\n"
	"FontPath   \"/usr/X11R6/lib/X11/fonts/75dpi/\"\n"
	"FontPath   \"/usr/X11R6/lib/X11/fonts/100dpi/\"\n"
	"EndSection\n"
	"Section \"ServerFlags\"\n"
	"EndSection\n"
	"Section \"Keyboard\"\n"
	"Protocol    \"Standard\"\n"
	"XkbModel \"pc102\"\n";
	/*
        XkbLayout "fr_CH"
	*/

	
		
