#include <gtk/gtk.h>
#include <stdlib.h>

#include "txt.h"

GtkWidget *text;
GtkWidget *label;

void update_lang(int l) {
	int i;
	for (i=0; i < NB_FRAME; i++) {
		gtk_label_set_text(
			GTK_LABEL(GTK_BIN(button_n[i])->child),
			lang_next[l]);		
		gtk_label_set_text(
			GTK_LABEL(GTK_BIN(button_b[i])->child),
			lang_back[l]);
		gtk_frame_set_label(GTK_FRAME(frame[i]),frame_name[i][l]);
	}
	gtk_label_set_text(
		GTK_LABEL(GTK_BIN(button_n[NB_FRAME-1])->child),
		lang_quit[l]);

	gtk_editable_delete_text (GTK_EDITABLE(text),0,-1);
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
		lang_wel[l],-1);
 	gtk_label_set_text(GTK_LABEL(label), lang_choose[l]);
	gtk_editable_delete_text (GTK_EDITABLE(key_txt_w),0,-1);
	gtk_text_insert (GTK_TEXT (key_txt_w), NULL, NULL, NULL,
		key_txt[l],-1);
	gtk_label_set_text(GTK_LABEL(key_map_w), key_map[l]);
	gtk_label_set_text(GTK_LABEL(key_name_w), key_name[l]);	

}
void lang_sel (GtkWidget *widget, gpointer data)
{
	int i;
	for (i=0; lang[i]; i++) {
		if (lang[i] == data) {
			setenv("LANG",lang_ext[i],1);
			update_lang(i);
		}
	}
}

void page_language(GtkWidget *table) 
{
	GtkWidget *radio;
	int i;

	label =gtk_label_new(lang_choose[DEF_LANG]);
	gtk_table_attach_defaults (GTK_TABLE(table), label, 1,6,2,3);
        gtk_widget_show(label);

	radio = gtk_radio_button_new_with_label (NULL, lang[0]);
	gtk_table_attach_defaults (GTK_TABLE(table), radio, 4,7,4,5);
	gtk_signal_connect (GTK_OBJECT (radio),  "clicked",
		GTK_SIGNAL_FUNC (lang_sel), (gpointer) lang[0]);
	gtk_widget_show(radio);
	for (i=1; lang[i]; i++) {
		radio = gtk_radio_button_new_with_label(
			gtk_radio_button_group (GTK_RADIO_BUTTON (radio)),
			lang[i]);
		gtk_signal_connect (GTK_OBJECT (radio),  "clicked",
			GTK_SIGNAL_FUNC (lang_sel), (gpointer) lang[i]);
		gtk_table_attach_defaults (GTK_TABLE(table), radio, 4,7,
			4+i,5+i);
        	gtk_widget_show(radio);
	}
	text = gtk_text_new (NULL, NULL);
	gtk_table_attach_defaults (GTK_TABLE(table), text, 9,15,3,18);
	gtk_widget_show (text);
	gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			lang_wel[0],-1);
	
}
