#include <gtk/gtk.h>
#include "txt.h"
#include "logo.xpm"

GtkWidget *notebook;
GtkWidget *window;
GtkWidget *frame[NB_FRAME];
GtkWidget *button_n[NB_FRAME];
GtkWidget *button_b[NB_FRAME];
extern void page_language(GtkWidget *table);
// extern void page_disk(GtkWidget *table);
extern void page_key(GtkWidget *table);
// extern void page_lilo(GtkWidget *table);
// extern void page_pack(GtkWidget *table);
// extern void page_ready(GtkWidget *table);

gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	return (FALSE);
}
void destroy (GtkWidget *widget, gpointer data)
{
	gtk_main_quit ();
}
void next (GtkWidget *widget, gpointer data)
{
	gtk_notebook_next_page(GTK_NOTEBOOK(data));
}
void back (GtkWidget *widget, gpointer data)
{
	gtk_notebook_prev_page(GTK_NOTEBOOK(data));
}
int main(int argc, char *argv[])
{
	int i;
	GtkWidget  *label;
	GtkWidget *table;
	GtkStyle  *style;
	GtkWidget *child = NULL;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkWidget *pixmapwid;
	gtk_init (&argc, &argv);
	style = gtk_widget_get_default_style();
	style = gtk_style_copy(style);
	style->bg[0].red = 40000;
	style->bg[0].green = 40000;
	style->bg[0].blue = 65000;
	gtk_widget_push_style(style);	
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	
	gtk_widget_set_usize(window, 640,480);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",
				GTK_SIGNAL_FUNC (delete_event), NULL);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
				GTK_SIGNAL_FUNC (destroy), NULL);
	gtk_container_border_width (GTK_CONTAINER (window), 0);
	gtk_widget_realize(window);
	
	notebook = gtk_notebook_new ();
	gtk_widget_pop_style();	
	gtk_container_set_border_width (GTK_CONTAINER (notebook), 0);
	gtk_notebook_set_show_tabs (GTK_NOTEBOOK(notebook), FALSE);
	gtk_container_add (GTK_CONTAINER (window), notebook);
	gtk_widget_show(notebook);

	for (i=0; i < NB_FRAME; i++) {
		child = gtk_frame_new (frame_name[i][DEF_LANG]);
		frame[i]= child;	
		gtk_container_set_border_width (GTK_CONTAINER (child), 10);
		gtk_widget_show(child);
	
		table = gtk_table_new(24,16,TRUE);
		gtk_container_add (GTK_CONTAINER (child), table);
		gtk_widget_show(table);
		//gtk_widget_realize(table);	

		if (i<NB_FRAME-1) {
			button_n[i] = gtk_button_new_with_label (
						lang_next[DEF_LANG]);
			gtk_signal_connect (GTK_OBJECT (button_n[i]), 
				"clicked",
				GTK_SIGNAL_FUNC(next),
				GTK_OBJECT(notebook));
		} else {
			button_n[i] = gtk_button_new_with_label (
                                                lang_quit[DEF_LANG]);
                        gtk_signal_connect (GTK_OBJECT (button_n[i]), 
                                "clicked",
                                GTK_SIGNAL_FUNC(destroy),
                                GTK_OBJECT(notebook));
		}
		gtk_table_attach_defaults (GTK_TABLE(table), button_n[i],
			13, //left_attach
			15, //right_attach
			21, //top_attach
			23); // bottom_attach
		gtk_widget_show(button_n[i]); 

		button_b[i] = gtk_button_new_with_label (lang_back[DEF_LANG]);
		gtk_signal_connect (GTK_OBJECT (button_b[i]), "clicked",
				GTK_SIGNAL_FUNC(back),
				GTK_OBJECT (notebook));
		gtk_table_attach_defaults (GTK_TABLE(table), button_b[i],
					11,13,21,23);
		if (i) { gtk_widget_show(button_b[i]); }
		
		pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
				&style->bg[GTK_STATE_NORMAL], logo_xpm);
		pixmapwid = gtk_pixmap_new (pixmap, mask);
		gtk_table_attach_defaults (GTK_TABLE(table),pixmapwid,
				0,2,20,23);
		gtk_widget_show(pixmapwid);
		switch (i) {
			case 0:		
				page_language(table);
				break;
			case 1:
				page_key(table);
				break;
	/*
			case 2:
				page_disk(table);
				break;
			case 3:
				page_pack(table);
				break;
			case 4:
				page_lilo(table);
				break;
			case 5:
				page_ready(table);
				break;
		*/
			default:
				page_language(table);
				break;
		}	
	
		label = gtk_label_new ("");
		gtk_widget_show(label);
		gtk_notebook_append_page(GTK_NOTEBOOK(notebook), child, label);
	}

	gtk_notebook_set_page (GTK_NOTEBOOK(notebook),0 );
	gtk_widget_show (window);
	gdk_window_set_cursor(window->window,gdk_cursor_new(GDK_HAND2));	
	gtk_main ();
	return 0;
}

