#include <sys/ioctl.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <X11/Intrinsic.h>
#include <X11/Xmd.h>
#include <X11/extensions/xf86misc.h>
#include <X11/Xos.h>
#include <string.h>

Display *display;
char *Mdevice = 0;
char *Mx_name;
char *Mg_name;
char *port[3] = {"/dev/ttyS0", "/dev/ttyS1", NULL};
int PS,fd[3],len,i,modem,cpt[3];
char buf[255];
struct termios *attr[3];
struct termios portattr[3],oldattr[3];
XF86MiscMouseSettings mseinfo;

int mouse_probe(void);
int main (int argc, char *argv[]) 
{
	char *arg[4];

	display = XOpenDisplay(":0.0");
	printf("*****************************************************\n");
	printf("*      MOUSE DETECTION : Please move the mouse!     *\n");
	printf("*****************************************************\n");
	mouse_probe();
	if(Mdevice) {
		arg[0] = Mdevice;
		arg[1] = Mx_name;
		setmouse(2, arg);
		XCloseDisplay(display);
		printf("Detected : %s %s %s\n", Mdevice, Mx_name, Mg_name);
		return 1;
	}
	printf("ERROR !!!\n");
	XCloseDisplay(display);
	return 1;
}

int  mouse_probe()
{
        XF86MiscGetMouseSettings(display, &mseinfo);
        if (mseinfo.device) {
                XtFree(mseinfo.device);
        }
	unlink("/dev/mouse");

	if ((PS=open("/dev/psaux", O_RDONLY|O_NONBLOCK))>0 ) {
		len = read( PS, buf, 255);
		close(PS);
		if (!((len == 1) && (buf[0] == -2))) {
			Mdevice = "/dev/psaux";
			Mx_name = "PS/2";
			Mg_name = "ps/2";
			return;
		}
	}
	i=0;
	while(port[i]) {
		fd[i] = open( port[i], O_RDWR | O_NONBLOCK);
		attr[i] = &portattr[i];
		tcgetattr(fd[i], attr[i]);
		tcgetattr(fd[i], &oldattr[i]);
	  	attr[i]->c_iflag = IGNBRK | IGNPAR;
    		attr[i]->c_cflag = 0;
    		attr[i]->c_cflag &= 
			~(CSIZE | CSTOPB | PARENB | PARODD | PARENB);
    		attr[i]->c_cflag |=  CREAD | CLOCAL;
		attr[i]->c_cflag |= CS7 | CSTOPB;
		attr[i]->c_oflag = 0;
    		attr[i]->c_lflag = 0;
    		attr[i]->c_cc[VMIN] = 1;
    		attr[i]->c_cc[VTIME] = 5;
    		cfsetospeed( attr[i], B1200);
    		cfsetispeed( attr[i], B1200);
		tcsetattr(fd[i],  TCSANOW, attr[i] );
		ioctl(fd[i], TIOCMGET, &modem);
		modem  &= ~( TIOCM_RTS | TIOCM_DTR);
		ioctl(fd[i], TIOCMSET, &modem);	
		usleep(150000);
		modem|= TIOCM_DTR | TIOCM_RTS;
		ioctl(fd[i], TIOCMSET, &modem);
		cpt[i]=0;
		i++;
	}
	
	len = 0;
	while(!Mdevice) {
		usleep(50000);
		i=0;
		len++;
		if (len > (10 * 60 * 20)) {
			printf("10 minutes timeout !!!\n");
			break;
		}
		while(port[i]) {
			cpt[i] += read( fd[i], buf, 255 );
			if(cpt[i] >20) {
				Mdevice = port[i];
                        	Mx_name = "Microsoft";
                        	Mg_name = "Microsoft";
				break;
			}
			i++;
		}
	}	
	i=0;
        while(port[i]) {
		tcsetattr(fd[i], TCSANOW, &oldattr[i]);
		close(fd[i]);
		i++;
	}
}

int setmouse (int argc, char *argv[])
{
        symlink(argv[0], "/dev/mouse");
        mseinfo.device = argv[0];
        mseinfo.type = 0;
        if (!strncmp("PS/2", argv[1], 4)) {
                mseinfo.type = 6;
        }
        mseinfo.baudrate = 1200;
        mseinfo.samplerate = 0;
        mseinfo.resolution = 0;
        mseinfo.buttons = 3;
        mseinfo.emulate3buttons = 1;
        mseinfo.emulate3timeout = 50;
        mseinfo.chordmiddle = 0;
        mseinfo.flags = 0;
        mseinfo.flags |= MF_REOPEN; // |MF_CLEAR_DTR |MF_CLEAR_RTS;
        XSync(display, False);
        XF86MiscSetMouseSettings(display, &mseinfo);
        XSync(display, False);
        return 0;
}

